%define major 0
%define pcreposix_major 1
%define libname_orig	lib%{name}
%define libname	%mklibname pcre %{major}
%define develname %mklibname -d pcre

%define build_pcreposix_compat 1

Summary: 	Perl-compatible regular expression library
Name:	 	pcre
Version:	8.12
Release:	%mkrel 2
License: 	BSD-Style
Group:  	File tools
URL: 		http://www.pcre.org/
Source0:	ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/%name-%version.tar.bz2
Source1:	ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/%name-%version.tar.bz2.sig
Requires: 	%{libname} = %{version}-%{release}
BuildRequires:	automake
Patch1:		pcre-0.6.5-fix-detect-into-kdelibs.patch
Patch2:		pcre-linkage_fix.diff
Patch3:		pcre-7.8-format_not_a_string_literal_and_no_format_arguments.diff
# from debian:
Patch4:		pcre-pcreposix-glibc-conflict.patch
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
PCRE has its own native API, but a set of "wrapper" functions that are based on
the POSIX API are also supplied in the library libpcreposix. Note that this
just provides a POSIX calling interface to PCRE: the regular expressions
themselves still follow Perl syntax and semantics. 
This package contains a grep variant based on the PCRE library.

%package -n	%{libname}
Group:		System/Libraries
Summary:	Perl-compatible regular expression library
Provides:	%{libname_orig} = %{version}-%{release}
Conflicts:	pcre <= 4.0

%description -n	%{libname}
PCRE has its own native API, but a set of "wrapper" functions that are based on
the POSIX API are also supplied in the library libpcreposix. Note that this
just provides a POSIX calling interface to PCRE: the regular expressions
themselves still follow Perl syntax and semantics. The header file
for the POSIX-style functions is called pcreposix.h. The official POSIX name is
regex.h, but I didn't want to risk possible problems with existing files of
that name by distributing it that way. To use it with an existing program that
uses the POSIX API, it will have to be renamed or pointed at by a link.

%package -n	%{develname}
Group:		Development/C
Summary:	Headers and static lib for pcre development
Requires:	%{libname} = %{version}-%{release}
Provides:	%{libname_orig}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%mklibname pcre 0 -d
Conflicts:	pcre <= 4.0

%description -n	%{develname}
Install this package if you want do compile applications using the pcre
library.

%prep

%setup -q
%patch1 -p1 -b .detect_into_kdelibs
%patch2 -p0
#%patch3 -p0 -b .format_not_a_string_literal_and_no_format_arguments


%if %{build_pcreposix_compat}
  # pcre-pcreposix-glibc-conflict patch below breaks compatibility,
  # create a libpcreposix.so.0 without the patch
  cp -a . ../pcre-with-pcreposix_compat && mv ../pcre-with-pcreposix_compat .
%endif
%patch4 -p1 -b .symbol-conflict

%build
%if %{build_pcreposix_compat}
dirs="pcre-with-pcreposix_compat ."
%else
dirs="."
%endif
for i in $dirs; do
  cd $i
  mkdir -p m4
  autoreconf -fis
  %configure2_5x --enable-utf8 --enable-unicode-properties
  %make
  cd -
done

%check
export LC_ALL=C
# Tests, patch out actual pcre_study_size in expected results
#echo 'int main() { printf("%d", sizeof(pcre_study_data)); return 0; }' | \
#%{__cc} -xc - -include "pcre_internal.h" -I. -o study_size
#STUDY_SIZE=`./study_size`
#perl -pi -e "s,(Study size\s+=\s+)\d+,\${1}$STUDY_SIZE," testdata/testoutput*
make check

%install
rm -rf $RPM_BUILD_ROOT
%if %{build_pcreposix_compat}
%makeinstall_std -C pcre-with-pcreposix_compat
%endif
%makeinstall_std

%multiarch_binaries $RPM_BUILD_ROOT%{_bindir}/pcre-config

mkdir -p $RPM_BUILD_ROOT/%_lib
mv $RPM_BUILD_ROOT/%_libdir/lib%{name}.so.%{major}.* $RPM_BUILD_ROOT/%_lib
cd $RPM_BUILD_ROOT/%_libdir
ln -s ../../%_lib/lib%{name}.so.%{major}.* .

# Remove unwanted files
rm -f $RPM_BUILD_ROOT/%_docdir/pcre/{AUTHORS,ChangeLog,COPYING,LICENCE,NEWS}
rm -f $RPM_BUILD_ROOT/%_docdir/pcre/{pcre-config.txt,pcre.txt,pcregrep.txt}
rm -f $RPM_BUILD_ROOT/%_docdir/pcre/{pcretest.txt,README}
rm -rf $RPM_BUILD_ROOT/%_docdir/pcre/html

%clean
rm -rf $RPM_BUILD_ROOT

%if %mdkversion < 200900
%post -n %{libname} -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun -n %{libname} -p /sbin/ldconfig
%endif
 
%files
%defattr(-,root,root)

%_mandir/man1/pcregrep.1*
%_mandir/man1/pcretest.1*
%_bindir/pcregrep  
%_bindir/pcretest


#
%files -n %{libname}
%defattr(-,root,root)
%doc AUTHORS COPYING LICENCE NEWS README

/%_lib/lib*.so.%{major}*
%_libdir/lib*.so.%{major}*
%_libdir/libpcreposix.so.%{pcreposix_major}*


#
%files -n %{develname}
%defattr(-,root,root)
%doc doc/html
%doc ChangeLog 

%_libdir/lib*.a
%_libdir/lib*.la
%_libdir/lib*.so
%_includedir/*.h
%_libdir/pkgconfig/libpcre.pc
%_libdir/pkgconfig/libpcrecpp.pc
%_libdir/pkgconfig/libpcreposix.pc

%_bindir/pcre-config
%{multiarch_bindir}/pcre-config

%_mandir/man1/pcre-config.1*
%_mandir/man3/*.3*


%changelog
* Mon May 02 2011 Oden Eriksson <oeriksson@mandriva.com> 8.12-2mdv2011.0
+ Revision: 661712
- multiarch fixes

* Tue Jan 18 2011 Oden Eriksson <oeriksson@mandriva.com> 8.12-1
+ Revision: 631526
- 8.12

* Thu Dec 23 2010 Oden Eriksson <oeriksson@mandriva.com> 8.11-1mdv2011.0
+ Revision: 624188
- 8.11

* Mon Jul 12 2010 Oden Eriksson <oeriksson@mandriva.com> 8.10-1mdv2011.0
+ Revision: 551258
- 8.10

* Fri Mar 19 2010 Funda Wang <fwang@mandriva.org> 8.02-1mdv2010.1
+ Revision: 525255
- update to new version 8.02

* Thu Jan 21 2010 Oden Eriksson <oeriksson@mandriva.com> 8.01-1mdv2010.1
+ Revision: 494479
- 8.01

* Fri Nov 06 2009 Oden Eriksson <oeriksson@mandriva.com> 8.00-1mdv2010.1
+ Revision: 461850
- fix build
- 8.00

* Wed Jun 10 2009 Oden Eriksson <oeriksson@mandriva.com> 7.9-1mdv2010.0
+ Revision: 384818
- 7.9
- rediff patches

* Thu Jan 15 2009 Pixel <pixel@mandriva.com> 7.8-3mdv2009.1
+ Revision: 329849
- add patch (from debian) to avoid symbol conflicts between libpcreposix and glibc
- change libpcreposix major since it is not backward compatible
- keep the previous libpcreposix.so.0 for backward compatibility

* Sun Dec 21 2008 Oden Eriksson <oeriksson@mandriva.com> 7.8-2mdv2009.1
+ Revision: 317123
- fix build with -Werror=format-security (P3)

* Fri Sep 05 2008 Frederik Himpe <fhimpe@mandriva.org> 7.8-1mdv2009.0
+ Revision: 281699
- Update to new version 7.8
- Use bz2 source tarballs instead of gz
- Remove CVE-2008-2371 patch, a fix for this security problem was
  integrated upstream

* Wed Jul 16 2008 Oden Eriksson <oeriksson@mandriva.com> 7.7-2mdv2009.0
+ Revision: 236328
- fix linkage
- P0: security fix for CVE-2008-2371

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Wed May 07 2008 Oden Eriksson <oeriksson@mandriva.com> 7.7-1mdv2009.0
+ Revision: 203261
- 7.7

* Mon Feb 18 2008 Thierry Vignaud <tv@mandriva.org> 7.6-2mdv2008.1
+ Revision: 171018
- rebuild
- fix "foobar is blabla" summary (=> "blabla") so that it looks nice in rpmdrake

* Tue Jan 29 2008 Funda Wang <fwang@mandriva.org> 7.6-1mdv2008.1
+ Revision: 159594
- update to new version 7.6

* Sat Jan 26 2008 Götz Waschk <waschk@mandriva.org> 7.5-3mdv2008.1
+ Revision: 158423
- enable unicode properties (bug #37183)

* Thu Jan 17 2008 Thierry Vignaud <tv@mandriva.org> 7.5-2mdv2008.1
+ Revision: 154148
- do not package big changelog

* Thu Jan 10 2008 Götz Waschk <waschk@mandriva.org> 7.5-1mdv2008.1
+ Revision: 147716
- new version

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Mon Dec 03 2007 Funda Wang <fwang@mandriva.org> 7.4-2mdv2008.1
+ Revision: 114471
- rebuild
- clean old conditions

* Sat Oct 13 2007 Funda Wang <fwang@mandriva.org> 7.4-1mdv2008.1
+ Revision: 97867
- New version 7.4

* Wed Aug 29 2007 Funda Wang <fwang@mandriva.org> 7.3-1mdv2008.0
+ Revision: 73286
- New version 7.3

  + Thierry Vignaud <tv@mandriva.org>
    - replace %%_datadir/man by %%_mandir!

* Tue Jun 19 2007 Götz Waschk <waschk@mandriva.org> 7.2-1mdv2008.0
+ Revision: 41508
- new version

* Wed May 16 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 7.1-1mdv2008.0
+ Revision: 27456
- Updated to 7.1.
- Some cleanups.


* Tue Dec 19 2006 Götz Waschk <waschk@mandriva.org> 7.0-1mdv2007.0
+ Revision: 100317
- fix typo
- new version
- update file list
- unpack patch

* Tue Oct 31 2006 Oden Eriksson <oeriksson@mandriva.com> 6.7-1mdv2007.1
+ Revision: 74476
- Import pcre

* Thu Jul 06 2006 Götz Waschk <waschk@mandriva.org> 6.7-1mdk
- New release 6.7

* Mon Feb 06 2006 Götz Waschk <waschk@mandriva.org> 6.6-1mdk
- New release 6.6

* Mon Feb 06 2006 Götz Waschk <waschk@mandriva.org> 6.5-4mdk
- run tests in C locale

* Sat Feb 04 2006 Laurent MONTEL <lmontel@mandriva.com> 6.5-3mdk
- Add patch1: fix detect pcre into kdelibs

* Fri Feb 03 2006 Götz Waschk <waschk@mandriva.org> 6.5-1mdk
- New release 6.5

* Tue Oct 18 2005 Olivier Thauvin <nanardon@mandriva.org> 6.4-1mdk
- 6.4

* Tue Aug 23 2005 Götz Waschk <waschk@mandriva.org> 6.3-1mdk
- New release 6.3

* Tue Aug 02 2005 Götz Waschk <waschk@mandriva.org> 6.2-1mdk
- New release 6.2

* Thu Jun 23 2005 Götz Waschk <waschk@mandriva.org> 6.1-1mdk
- New release 6.1

* Tue Jun 14 2005 Götz Waschk <waschk@mandriva.org> 6.0-1mdk
- mv pkgconfig file to the devel package
- fix tests
- add source URL
- new version

* Mon Jan 31 2005 Laurent MONTEL <lmontel@mandrakesoft.com> 5.0-2mdk
- Fix multiarch

* Thu Nov 25 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 5.0-1mdk
- 5.0

* Mon May 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 4.5-5mdk
- fix buildrequires

* Mon May 24 2004 Abel Cheung <deaddog@deaddog.org> 4.5-4mdk
- (gb) fix deps
- Don't need to regen auto* stuff, cputoolize would do the job
- Use UTF-8 for spec!

* Wed Mar 24 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 4.5-3mdk
- Fix update from 9.1

* Tue Mar 02 2004 Götz Waschk <waschk@linux-mandrake.com> 4.5-2mdk
- use the mdkversion macro
- fix buildrequires

